VERSION 5.00
Begin VB.Form dlgADCConfig 
   Caption         =   "Temp. ADC Configuration"
   ClientHeight    =   7170
   ClientLeft      =   60
   ClientTop       =   4785
   ClientWidth     =   4470
   Icon            =   "dlgADCConfig.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   7170
   ScaleWidth      =   4470
   Begin VB.CheckBox chkADCS 
      Alignment       =   1  'Right Justify
      Caption         =   "Single Shot conv :"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   238
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2400
      TabIndex        =   41
      ToolTipText     =   "Bit ADCS (#12)"
      Top             =   2160
      Value           =   1  'Checked
      Width           =   1695
   End
   Begin VB.CommandButton cmdApply 
      Caption         =   "Apply"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3000
      TabIndex        =   37
      Top             =   960
      Width           =   1215
   End
   Begin VB.Frame frmADCext 
      Caption         =   "ADC Configuration with External Source"
      Height          =   3735
      Left            =   120
      TabIndex        =   14
      Top             =   3360
      Width           =   4215
      Begin VB.Frame frmADCref 
         Caption         =   "Ref select"
         Height          =   2415
         Left            =   120
         TabIndex        =   23
         Top             =   600
         Width           =   2055
         Begin VB.CheckBox chkADC1110mode 
            Alignment       =   1  'Right Justify
            Caption         =   "ADC built-in 2.048V:"
            Height          =   255
            Left            =   120
            TabIndex        =   28
            ToolTipText     =   "Bit AREN (#8)"
            Top             =   240
            Width           =   1815
         End
         Begin VB.OptionButton optVref 
            Alignment       =   1  'Right Justify
            Caption         =   "Reserved:"
            Height          =   255
            Index           =   3
            Left            =   840
            TabIndex        =   27
            ToolTipText     =   "Bits RV[1:0] (#7:6)  = 11"
            Top             =   1320
            Width           =   1095
         End
         Begin VB.OptionButton optVref 
            Alignment       =   1  'Right Justify
            Caption         =   "Vsa pin:"
            Height          =   255
            Index           =   2
            Left            =   840
            TabIndex        =   26
            ToolTipText     =   "Bits RV[1:0] (#7:6)  = 10"
            Top             =   1080
            Width           =   1095
         End
         Begin VB.OptionButton optVref 
            Alignment       =   1  'Right Justify
            Caption         =   "Vexc pin:"
            Height          =   255
            Index           =   1
            Left            =   840
            TabIndex        =   25
            ToolTipText     =   "Bits RV[1:0] (#7:6)  = 01"
            Top             =   840
            Width           =   1095
         End
         Begin VB.OptionButton optVref 
            Alignment       =   1  'Right Justify
            Caption         =   "Vref pin:"
            Height          =   255
            Index           =   0
            Left            =   840
            TabIndex        =   24
            ToolTipText     =   "Bits RV[1:0] (#7:6)  = 00"
            Top             =   600
            Value           =   -1  'True
            Width           =   1095
         End
         Begin VB.Label Label4 
            Caption         =   "Note: Bits RV[1:0] do not have effect when the built-in Vref is selected"
            Height          =   615
            Left            =   120
            TabIndex        =   30
            Top             =   1680
            Width           =   1815
         End
      End
      Begin VB.Frame frmADCinp 
         Caption         =   "Diff input"
         Height          =   1335
         Left            =   2280
         TabIndex        =   18
         Top             =   1680
         Width           =   1815
         Begin VB.OptionButton optDiffIn 
            Alignment       =   1  'Right Justify
            Caption         =   "Vref - TEMPin"
            Height          =   255
            Index           =   3
            Left            =   120
            TabIndex        =   22
            ToolTipText     =   "Bits M[1:0] (#5:4) = 11"
            Top             =   960
            Width           =   1575
         End
         Begin VB.OptionButton optDiffIn 
            Alignment       =   1  'Right Justify
            Caption         =   "(*) Vout - GNDA"
            BeginProperty Font 
               Name            =   "Arial"
               Size            =   8.25
               Charset         =   238
               Weight          =   400
               Underline       =   0   'False
               Italic          =   -1  'True
               Strikethrough   =   0   'False
            EndProperty
            ForeColor       =   &H00800000&
            Height          =   255
            Index           =   2
            Left            =   120
            TabIndex        =   21
            ToolTipText     =   "Bits M[1:0] (#5:4) = 10"
            Top             =   720
            Width           =   1575
         End
         Begin VB.OptionButton optDiffIn 
            Alignment       =   1  'Right Justify
            Caption         =   "Vexc - TEMPin"
            Height          =   255
            Index           =   1
            Left            =   120
            TabIndex        =   20
            ToolTipText     =   "Bits M[1:0] (#5:4) = 01"
            Top             =   480
            Width           =   1575
         End
         Begin VB.OptionButton optDiffIn 
            Alignment       =   1  'Right Justify
            Caption         =   "TEMPin - GNDa"
            Height          =   255
            Index           =   0
            Left            =   120
            TabIndex        =   19
            ToolTipText     =   "Bits M[1:0] (#5:4) = 00"
            Top             =   240
            Value           =   -1  'True
            Width           =   1575
         End
      End
      Begin VB.Frame frmPreGain 
         Caption         =   "ADC Pre-gain"
         Height          =   1335
         Left            =   2280
         TabIndex        =   17
         Top             =   240
         Width           =   1815
         Begin VB.OptionButton optPreGain 
            Alignment       =   1  'Right Justify
            Caption         =   "8 V/V"
            Height          =   255
            Index           =   3
            Left            =   960
            TabIndex        =   34
            ToolTipText     =   "Bits M[1:0] (#5:4) = 11"
            Top             =   960
            Width           =   735
         End
         Begin VB.OptionButton optPreGain 
            Alignment       =   1  'Right Justify
            Caption         =   "4 V/V"
            Height          =   255
            Index           =   2
            Left            =   960
            TabIndex        =   33
            ToolTipText     =   "Bits M[1:0] (#5:4) = 10"
            Top             =   720
            Width           =   735
         End
         Begin VB.OptionButton optPreGain 
            Alignment       =   1  'Right Justify
            Caption         =   "2 V/V"
            Height          =   255
            Index           =   1
            Left            =   960
            TabIndex        =   32
            ToolTipText     =   "Bits M[1:0] (#5:4) = 01"
            Top             =   480
            Width           =   735
         End
         Begin VB.OptionButton optPreGain 
            Alignment       =   1  'Right Justify
            Caption         =   "1 V/V"
            Height          =   255
            Index           =   0
            Left            =   960
            TabIndex        =   31
            ToolTipText     =   "Bits G[1:0] (#3:2) = 00"
            Top             =   240
            Value           =   -1  'True
            Width           =   735
         End
         Begin VB.Label Label5 
            Caption         =   "Select ADC input gain "
            Height          =   615
            Left            =   120
            TabIndex        =   36
            Top             =   360
            Width           =   735
         End
      End
      Begin VB.CheckBox chkADCTurbo 
         Alignment       =   1  'Right Justify
         Caption         =   "Enable ADC 2x Turbo:"
         Height          =   255
         Left            =   120
         TabIndex        =   16
         ToolTipText     =   "Bit ADC2x (#13)"
         Top             =   240
         Width           =   1935
      End
      Begin VB.Label Label2 
         Caption         =   "(*) Vout-GNDA input is not compatible with the stand- alone look-up table PGA309 mode. Pull Test pin high."
         Height          =   495
         Left            =   120
         TabIndex        =   35
         Top             =   3120
         Width           =   3975
      End
   End
   Begin VB.Frame frmSource 
      Height          =   2775
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   2175
      Begin VB.CheckBox chkItemp 
         Alignment       =   1  'Right Justify
         Caption         =   "Enable Itemp (~7uA):"
         Height          =   255
         Left            =   120
         TabIndex        =   15
         ToolTipText     =   "Bit ISEN (#11)"
         Top             =   2400
         Width           =   1935
      End
      Begin VB.Frame frmRsln 
         Caption         =   "Resolution, without sign"
         Height          =   975
         Left            =   120
         TabIndex        =   7
         Top             =   1320
         Width           =   1935
         Begin VB.OptionButton optRsln 
            Height          =   255
            Index           =   0
            Left            =   120
            TabIndex        =   39
            ToolTipText     =   "Bits R[1:0] (#1:0)  = 00"
            Top             =   600
            Value           =   -1  'True
            Width           =   255
         End
         Begin VB.OptionButton optRsln 
            Height          =   255
            Index           =   3
            Left            =   1500
            TabIndex        =   10
            ToolTipText     =   "Bits R[1:0] (#1:0)  = 11"
            Top             =   600
            Width           =   255
         End
         Begin VB.OptionButton optRsln 
            Height          =   255
            Index           =   2
            Left            =   1035
            TabIndex        =   9
            ToolTipText     =   "Bits R[1:0] (#1:0)  = 10"
            Top             =   600
            Width           =   255
         End
         Begin VB.OptionButton optRsln 
            Height          =   255
            Index           =   1
            Left            =   585
            TabIndex        =   8
            ToolTipText     =   "Bits R[1:0] (#1:0)  = 01"
            Top             =   600
            Width           =   255
         End
         Begin VB.Label lblRsln 
            Caption         =   "12"
            Height          =   255
            Index           =   0
            Left            =   120
            TabIndex        =   40
            Top             =   240
            Width           =   375
         End
         Begin VB.Label lblRsln 
            Caption         =   "13"
            Height          =   255
            Index           =   1
            Left            =   525
            TabIndex        =   13
            Top             =   240
            Width           =   375
         End
         Begin VB.Label lblRsln 
            Caption         =   "14"
            Height          =   255
            Index           =   2
            Left            =   975
            TabIndex        =   12
            Top             =   240
            Width           =   375
         End
         Begin VB.Label lblRsln 
            Caption         =   "16"
            Height          =   255
            Index           =   3
            Left            =   1440
            TabIndex        =   11
            Top             =   240
            Width           =   375
         End
      End
      Begin VB.OptionButton optTMPmode 
         Alignment       =   1  'Right Justify
         Caption         =   "Internal on-chip temp "
         Height          =   255
         Index           =   1
         Left            =   120
         TabIndex        =   6
         ToolTipText     =   "Bit TEN (#9) = 1"
         Top             =   960
         Width           =   1935
      End
      Begin VB.OptionButton optTMPmode 
         Alignment       =   1  'Right Justify
         Caption         =   "External (TEMPin pin)"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   4
         ToolTipText     =   "Bit TEN (#9) = 0"
         Top             =   600
         Value           =   -1  'True
         Width           =   1935
      End
      Begin VB.Label Label1 
         Caption         =   "Select Signal Source:"
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   8.25
            Charset         =   238
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   240
         Width           =   1935
      End
   End
   Begin VB.CheckBox chkADCenbl 
      Alignment       =   1  'Right Justify
      Caption         =   "Continuous conv :"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   238
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2400
      TabIndex        =   2
      ToolTipText     =   "Bit CEN (#10)"
      Top             =   1800
      Value           =   1  'Checked
      Width           =   1695
   End
   Begin VB.CommandButton CancelButton 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3000
      TabIndex        =   1
      Top             =   1440
      Width           =   1215
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3000
      TabIndex        =   0
      Top             =   480
      Width           =   1215
   End
   Begin VB.Label Label6 
      Caption         =   "Move your mouse cursor over the choices to see corresponding register bits"
      Height          =   495
      Left            =   120
      TabIndex        =   38
      Top             =   0
      Width           =   4215
   End
   Begin VB.Label lblMessage 
      ForeColor       =   &H00800000&
      Height          =   855
      Left            =   2400
      TabIndex        =   29
      Top             =   2520
      Width           =   1935
   End
End
Attribute VB_Name = "dlgADCConfig"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim VrefChannel, VinChannel, ADCGain, Resoln As Long
Dim TMPmode As Integer
Dim ApplyActive As Boolean  'flag if apply button caused the update

Private Sub Form_Activate()
  ApplyActive = False   'clear the flag
  Call UpdateADCDialog
End Sub

'Private Sub Form_Deactivate()
'    Call dlgADCConfig.Hide
'End Sub

Private Sub cmdApply_Click()
    ApplyActive = True  'set the flag
    Call SetRegBits(VrefChannel, 6, 6, 7)
    Call SetRegBits(VinChannel, 6, 4, 5)
    Call SetRegBits(ADCGain, 6, 2, 3)
    Call SetRegBits(Resoln, 6, 0, 1)
    
    Call SetRegBits(TMPmode, 6, 9, 9)    'onchip temp

    Call SetRegBits(chkADC1110mode.Value, 6, 8, 8)
    Call SetRegBits(chkADCenbl.Value, 6, 10, 10)
    Call SetRegBits(chkADCS.Value, 6, 12, 12)
    Call SetRegBits(chkItemp.Value, 6, 11, 11)
    Call SetRegBits(chkADCTurbo.Value, 6, 13, 13)
    Call UpdateRegisterDisplay
    ApplyActive = False     'clear the flag
End Sub

Private Sub OKButton_Click()
    Call cmdApply_Click
    Call dlgADCConfig.Hide
End Sub

Private Sub CancelButton_Click()
    Call dlgADCConfig.Hide
End Sub

Private Sub optTMPmode_Click(Index As Integer)
    Dim BaseResolnLabel As Integer
    TMPmode = Index
    If (Index = 0) Then
'    And (chkADCenbl.Value = 1) Then
        BaseResolnLabel = 11
        lblMessage.Caption = ""
'        frmADCext.Enabled = True
        optVref(0).Enabled = True
        optVref(1).Enabled = True
        optVref(2).Enabled = True
        optVref(3).Enabled = True
        optPreGain(0).Enabled = True
        optPreGain(1).Enabled = True
        optPreGain(2).Enabled = True
        optPreGain(3).Enabled = True
        chkADC1110mode.Enabled = True
        optDiffIn(0).Enabled = True
        optDiffIn(1).Enabled = True
        optDiffIn(2).Enabled = True
        optDiffIn(3).Enabled = True
        Label4.Enabled = True
        Label5.Enabled = True
        frmADCref.Enabled = True
        frmPreGain.Enabled = True
        frmADCinp.Enabled = True
    Else
        BaseResolnLabel = 9
        lblMessage.Caption = "Note: ADC ref and input config bits are" _
                            & " ignored when on-chip temp measurement is ON."
'        frmADCext.Enabled = False
        optVref(0).Enabled = False
        optVref(1).Enabled = False
        optVref(2).Enabled = False
        optVref(3).Enabled = False
        optPreGain(0).Enabled = False
        optPreGain(1).Enabled = False
        optPreGain(2).Enabled = False
        optPreGain(3).Enabled = False
        chkADC1110mode.Enabled = False
        optDiffIn(0).Enabled = False
        optDiffIn(1).Enabled = False
        optDiffIn(2).Enabled = False
        optDiffIn(3).Enabled = False
        Label4.Enabled = False
        Label5.Enabled = False
        frmADCref.Enabled = False
        frmPreGain.Enabled = False
        frmADCinp.Enabled = False
    End If
    If BaseResolnLabel = 11 Then
        lblRsln(0) = CStr(BaseResolnLabel) & "b"
        lblRsln(1) = CStr(BaseResolnLabel + 2) & "b"
        lblRsln(2) = CStr(BaseResolnLabel + 3) & "b"
        lblRsln(3) = CStr(BaseResolnLabel + 4) & "b"
    Else
        lblRsln(0) = CStr(BaseResolnLabel) & "b"
        lblRsln(1) = CStr(BaseResolnLabel + 1) & "b"
        lblRsln(2) = CStr(BaseResolnLabel + 2) & "b"
        lblRsln(3) = CStr(BaseResolnLabel + 3) & "b"
    End If
End Sub

            ' assigning appropiate channel numbers when click occurs
Private Sub optVref_Click(Index As Integer)
    VrefChannel = Index
End Sub

Private Sub optDiffIn_Click(Index As Integer)
    VinChannel = Index
End Sub

Private Sub optPreGain_Click(Index As Integer)
    ADCGain = Index
End Sub

Private Sub optRsln_Click(Index As Integer)
    Resoln = Index
End Sub

Private Sub chkADC1110mode_Click()
'    If chkADC1110mode.Value = 1 Then
'        optVref(0).Enabled = False
'        optVref(1).Enabled = False
'        optVref(2).Enabled = False
'        optVref(3).Enabled = False
'    Else
'        optVref(0).Enabled = True
'        optVref(1).Enabled = True
'        optVref(2).Enabled = True
'        optVref(3).Enabled = True
'    End If
End Sub

Private Sub chkADCenbl_Click()
    If chkADCenbl.Value = 0 And chkADCS.Value = 0 Then
        lblMessage.Caption = "Note: See PDS on the PGA309 behaviour when both ADCS, CEN = 0"
    Else
        lblMessage.Caption = ""
    End If
End Sub

Private Sub chkADCS_Click()
    If chkADCenbl.Value = 0 And chkADCS.Value = 0 Then
        lblMessage.Caption = "Note: See PDS on the PGA309 behaviour when both ADCS, CEN = 0"
    Else
        lblMessage.Caption = ""
    End If
End Sub

Public Sub UpdateADCDialog()
    If Not ApplyActive Then     ' if not the apply button caused the update
            ' recovering the assignments from the bitwise register values
        chkADCenbl.Value = RegBits2Index(6, 10, 10)
        chkADCS.Value = RegBits2Index(6, 12, 12)
                                                    'on-chip temp enbl
        optTMPmode(RegBits2Index(6, 9, 9)).Value = True
        Call optTMPmode_Click(RegBits2Index(6, 9, 9))
        VrefChannel = RegBits2Index(6, 6, 7)
        optVref(VrefChannel).Value = True
        VinChannel = RegBits2Index(6, 4, 5)
        optDiffIn(VinChannel).Value = True
        ADCGain = RegBits2Index(6, 2, 3)
        optPreGain(ADCGain).Value = True
        Resoln = RegBits2Index(6, 0, 1)
        optRsln(Resoln).Value = True
        
        chkADC1110mode.Value = RegBits2Index(6, 8, 8)     'ADC's own ref
        chkItemp.Value = RegBits2Index(6, 11, 11)
        chkADCTurbo.Value = RegBits2Index(6, 13, 13)
        OKButton.Default = True
        Call chkADCenbl_Click
    End If
End Sub
