VERSION 5.00
Begin VB.Form formFullEEPROM 
   Caption         =   "PGA309 Board:  1 KBit EEPROM Content"
   ClientHeight    =   3675
   ClientLeft      =   7005
   ClientTop       =   510
   ClientWidth     =   5835
   Icon            =   "formFullEEPROM.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3675
   ScaleWidth      =   5835
   Begin VB.CommandButton cmdRead 
      Caption         =   "Read EEPROM"
      Height          =   375
      Left            =   4320
      TabIndex        =   4
      Top             =   1320
      Width           =   1335
   End
   Begin VB.CommandButton cmdWrite 
      Caption         =   "Write EEPROM"
      Height          =   375
      Left            =   4320
      TabIndex        =   3
      Top             =   840
      Width           =   1335
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "Close"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4320
      TabIndex        =   2
      Top             =   360
      Width           =   1335
   End
   Begin VB.TextBox txtAsc 
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3255
      Left            =   2880
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   360
      Width           =   1335
   End
   Begin VB.TextBox txtHex 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3255
      Left            =   600
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   360
      Width           =   2295
   End
   Begin VB.Label lblMsg 
      Caption         =   "EEPROM data is not available"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1215
      Left            =   4320
      TabIndex        =   9
      Top             =   1920
      Width           =   1335
   End
   Begin VB.Label lblHead 
      Caption         =   "ASCII"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Index           =   2
      Left            =   2880
      TabIndex        =   8
      Top             =   120
      Width           =   495
   End
   Begin VB.Label lblHead 
      Caption         =   "Hex"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Index           =   1
      Left            =   720
      TabIndex        =   7
      Top             =   120
      Width           =   495
   End
   Begin VB.Label lblHead 
      Caption         =   "Addr"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   6
      Top             =   120
      Width           =   495
   End
   Begin VB.Label lblAddr 
      Height          =   3255
      Left            =   120
      TabIndex        =   5
      Top             =   360
      Width           =   495
   End
End
Attribute VB_Name = "formFullEEPROM"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private TextChanged As Boolean
Private ROMArray() As Byte

Private Sub cmdClose_Click()
    cmdClose.SetFocus
    If TextChanged Then
            'if the text has changed, the validation sub
            ' should already have updated the ROMArray()
        Dim Msg As String, Style As VbMsgBoxStyle
        Dim Title As String, Response As VbMsgBoxResult
        Msg = "Update the EEPROM content?"  ' Define message.
        Style = vbYesNo + vbQuestion
        Title = "PGA309 Designer's Kit"   ' Define title.
        Response = MsgBox(Msg, Style, Title)  'if the table is already full
        If Response = vbYes Then
            Call cmdWrite_Click
        End If
    End If
    Unload Me
End Sub

Private Sub cmdRead_Click()
    formFullEEPROM.MousePointer = vbHourglass ' change pointer to hourglass
'    On Error GoTo NoDisplay 'trap errors
    formMain.timerBusAlive.Enabled = False   'disable the timer
    ROMArray = ReadFull1KEEPROM
    Call formMain.chkKeepBusAlive_Click      'restore the timer
    If UBound(ROMArray) <= 0 Then
        lblAddr.Caption = ""
        txtHex.Text = ""
        txtAsc.Text = ""
        lblMsg.Caption = "EEPROM data is not available"
    Else
        Call DisplayFullEEPROM
    End If
    TextChanged = False
'    On Error GoTo 0    'resume system error handling
    formFullEEPROM.MousePointer = 0 ' change pointer to normal
End Sub

Private Sub cmdWrite_Click()
    If UBound(ROMArray) > 0 Then
        MousePointer = vbHourglass ' change pointer to hourglass
        formMain.timerBusAlive.Enabled = False   'disable the timer
        Call WriteFull1KEEPROM(ROMArray)  'write the array
        If BoardConnected Then
            Call ReadEEPROM     're-read it back to the registers in the main window
        End If
        Call formMain.chkKeepBusAlive_Click      'restore the timer
        MousePointer = 0 ' change pointer to normal
    Else
        Beep
    End If
End Sub

Private Sub Form_Load()
    Call cmdRead_Click
End Sub

Private Sub txtHex_Change()
    TextChanged = True
End Sub

Private Sub txtHex_Validate(Cancel As Boolean)
    'validates the HEX values edited by the user
If TextChanged Then
    Dim HexStr As String
    Dim CurrNum As String
    Dim ByteArray() As Byte
    Dim i As Integer
    ReDim ByteArray(127)
    i = 0
    HexStr = txtHex.Text
    Do While Len(HexStr) > 0 And i < 128
        Do While Not (IsDigit(Left$(HexStr, 1))) And Len(HexStr) > 0
            HexStr = Right(HexStr, Len(HexStr) - 1)
        Loop
        If Len(HexStr) > 0 Then
            CurrNum = Left(HexStr, 1)
            HexStr = Right(HexStr, Len(HexStr) - 1)
            If IsDigit(Left$(HexStr, 1)) Then
                CurrNum = CurrNum & Left(HexStr, 1)
                HexStr = Right(HexStr, Len(HexStr) - 1)
            End If
        End If
        ByteArray(i) = CByte("&H" & CurrNum)
        i = i + 1
    Loop
    ReDim Preserve ByteArray(i - 1) 'trim the array
    ROMArray = ByteArray
    DisplayFullEEPROM
End If
End Sub

Private Sub DisplayFullEEPROM()
    ' Displays the ROMArray in the textboxes
    Dim i As Integer, j As Integer
    Dim HexStr As String, AscStr As String, AddrStr As String
    AddrStr = ""
    HexStr = ""
    AscStr = ""
    i = 0
    Do While i < UBound(ROMArray)
        AddrStr = AddrStr & Str(i) & vbCrLf
        For j = 0 To 7
                'build a row of 8 bytes
            If (i + j) < UBound(ROMArray) Then
                    'make sure we don't exceed the array length
                If ROMArray(i + j) < 16 Then
                            ' add leading zero
                    HexStr = HexStr & "0" & Hex(ROMArray(i + j)) & " "
                Else
                    HexStr = HexStr & Hex(ROMArray(i + j)) & " "
                End If
                If ROMArray(i + j) < 32 Then
                        'non-printable char - replace with space
                    AscStr = AscStr & "  "
                Else
                    AscStr = AscStr & Chr(ROMArray(i + j)) & " "
                End If
            End If
        Next j
        HexStr = HexStr & vbCrLf
        AscStr = AscStr & vbCrLf
        i = i + 8
    Loop
    lblAddr.Caption = AddrStr
    txtHex.Text = HexStr
    txtAsc.Text = AscStr
    lblMsg.Caption = ""
End Sub
